#! /bin/bash
AST_SRC_DIR=$1
common()
{
INSTALL_DIR=$PWD
ifconfig
          echo
	  echo "here"
	 read -p "CHOOSE THE ETERNET DRIVER IN WHICH YOU HAVE HWaddr 00:17:F7:XX:XX:XX Eg:1 for eth1 : " res
          echo 
          echo    "YOU HAVE SELECTED THE ETHERNET INTERFACE AS eth$res "
          echo
          read -p "CHOOSE DIFFERENT IP OTHER THAN YOUR NETWORK FOR TRANSCODING CARD Eg:10.1.1.1 : " ip
          ifconfig eth$res $ip netmask 255.255.255.0
          echo 
          echo "###########################################################################################"
          echo 
          echo                    "SELECTD THE IP FOR TRANSCODING CARD"
          echo
          echo "###########################################################################################"
          echo
          echo "###########################################################################################"
          echo 
          echo "COPYING CODEC FIELS TO old_codec IN $AST_MOD_DIR TO AVOID CONFLICTING WITH ALLO TRANSCODING"
          echo
          echo "###########################################################################################"  
mkdir $AST_MOD_DIR/old_codec
mv  $AST_MOD_DIR/codec_*  $AST_MOD_DIR/old_codec
ifconfig
cd $INSTALL_DIR/allo.i686/
make clean
make asterisk
make install
cd allotc_cfg
./allotc_cfg --server --asterisk --astdir=$AST_CONF_DIR --srvdir=/etc/allotc/
allotc_server_ctrl start
if [ $? -ne  0 ];then
          echo 
          echo "SERVER CONFIGURATION WENT WRONG ....RUN AGAIN BY PROPERLY SELECTING THE TRANSCODING CARD"
          echo
          exit 1
fi
grep "ALLO" $AST_CONF_DIR/allo_codec.conf
if [ $? -ne 0 ]; then
cat >> $AST_CONF_DIR/allo_codec.conf << EOF
###########################ALLO#################################
   allownondahditiming=yes
   register=g726
   register=g722
   register=g723.1
   register=ulaw
   register=alaw
   register=ilbc
######################CONFIG_FILE###############################
EOF
fi
grep "ALLO_SERVER" /etc/rc.local
if [ $? -ne 0 ];then
cat >> /etc/rc.local << EOF
#######################ALLO_SERVER##############################

         ifconfig eth$res $ip netmask 255.255.255.0
         allotc_server_ctrl start

#######################ALLO_SERVER###############################
EOF
fi
grep codec_allotc.so $AST_CONF_DIR/modules.conf
if [ $? -ne 0 ];then
            echo "load => codec_allotc.so" >> $AST_CONF_DIR/modules.conf
fi
            echo
            echo "#################################################################"
            echo
            echo         "ENTER THE MACHINE IP IN $AST_CONF_DIR/allo_codec.conf"
            echo
            echo "##################################################################"
            echo
exit 0
}

if [ "$1" != "" ];then
INSTALL_DIR=$PWD
default()
{
           grep "DEFAULT_MODULE_DIR"  $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
           sed -e s/#define.DEFAULT_MODULE_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
           AST_MOD_DIR=`sed -e s/\"$// /tmp/gsmtmp1`

           grep "DEFAULT_CONFIG_DIR"  $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
           sed -e s/#define.DEFAULT_CONFIG_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
           AST_CONF_DIR=`sed s/\"$// /tmp/gsmtmp1`
}

ast()
{
            grep "AST_CONFIG_DIR" $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
            sed -e s/#define.AST_CONFIG_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
            AST_CONF_DIR=`sed -e s/\"$// /tmp/gsmtmp1`

            grep "AST_MODULE_DIR"  $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
            sed -e s/#define.AST_MODULE_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
            AST_MOD_DIR=`sed s/\"$// /tmp/gsmtmp1`
}


grep DEFAULT_MODULE_DIR $AST_SRC_DIR/defaults.h
if [ $? == 0 ]
then
        default;
else
        ast;
fi
grep ^prefix  $AST_SRC_DIR/makeopts > /tmp/path
ast=`cat /tmp/path` 
path=${ast#*=}
AST_INC_DIR=$path
rm /tmp/path
cat > $INSTALL_DIR/script.sh << EOF
AST_CONFIG_PATH = $AST_CONF_DIR 
AST_MODULE_PATH = $AST_MOD_DIR
AST_INCLUDE_PATH = $AST_INC_DIR
EOF
chmod u+x $INSTALL_DIR/script.sh
common
else
INSTALL_DIR=$PWD
if [ -e /usr/include/asterisk ]; then
                echo "#############################################################"
                echo
                echo            "ASTERISK HEADER FILES FOUND"
                echo
                echo "#############################################################"
else
               yum search asterisk > /tmp/ast
               grep ^asterisk16-devel /tmp/ast >> /tmp/ast1
               filename=`cat /tmp/ast1`
               AST_DEVEL=${filename/: St*/}
               yum install $AST_DEVEL
fi
uname -m>>li
lb=`cat li`
rm li
if [ $lb == i686 ] || [ $lb == i386 ]; then
libd=lib
else
libd=lib64
fi
AST_CONF_DIR=/etc/asterisk
AST_MOD_DIR=/usr/$libd/asterisk/modules
AST_INC_DIR=/usr
cat > $INSTALL_DIR/script.sh << EOF
AST_CONFIG_PATH = $AST_CONF_DIR 
AST_MODULE_PATH = $AST_MOD_DIR
AST_INCLUDE_PATH = $AST_INC_DIR
EOF
chmod u+x $INSTALL_DIR/script.sh

                echo
                read -p "DO YOU WANT TO PROCEED TO TRIX-BOX/ELASTIX TRANSCODING INSTALLATION : Y/N  " r 
                echo
case $r in
        [Yy]* )  common;;
 
	[Nn]* )  echo
                 echo "RUN THE 'install.sh' SCRIPT WITH ASTERISK SOURCE PATH ./install.sh <ast_src_dir>"
                 echo
                 echo "EXAMPLE: ./install.sh /usr/src/asterisk-x.x.x "
                 echo
                 exit 1  ;;

           * )  echo 
                echo "INVALID OPTION TRY AGAIN"
                echo
                exit 1 ;;
 esac
fi  

